
#ifdef HAVE_IPV6
#include <ip6.h>
#endif /* HAVE_IPV6 */

#include <sys/types.h>
#include <winsock2.h>

//#include <netinet/in.h>
//#include <arpa/inet.h> /* inet_ntop defined there */
#if defined (__GLIBC__) && __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 1
#include <netinet/ip6.h>
#include <netinet/icmp6.h>
#else /* __GLIBC__ */
#ifdef __linux__
#include <netinet/ipv6.h>
#include <netinet/icmpv6.h>
#else /* __linux__ */
#ifdef NRL_IPV6
#include <netinet6/in6_types.h>
#include <netinet6/in6.h>
#endif /* NRL_IPV6 */
#endif /* __linux__ */
#endif /* __GLIBC__ */

int strncasecmp(char *s1, char *s2, int n) {
	char *cp1, *cp2;

	cp1 = s1;
	cp2 = s2;

	while ((n-- >0) && (*cp1 != '\0') && (*cp2 != '\0')) {
		if (*cp1 != *cp2) {return (1);}
		cp1++;
		cp2++;
	}

	//if ((*cp1 == '\0') && (*cp2 == '\0'))
	//	return (0);

	return (0);

}


int strcasecmp(char *s1, char *s2) {

		return (strncasecmp (s1, s2, strlen(s1)));

}

char *alloca(int size) {

}


int waitpid () {

}


int fork () {



}

int pipe () {

}


#ifdef HAVE_IPV6

int IN6_IS_ADDR_UNSPECIFIED (const struct in6_addr *a)
{
    return ((a->s6_dwords[0] == 0) &&
            (a->s6_dwords[1] == 0) &&
            (a->s6_dwords[2] == 0) &&
            (a->s6_dwords[3] == 0));
}

int IN6_IS_ADDR_LOOPBACK(const struct in6_addr *a)
{
    return ((a->s6_dwords[0] == 0) &&
            (a->s6_dwords[1] == 0) &&
            (a->s6_dwords[2] == 0) &&
            (a->s6_dwords[3] == htonl(1)));
}
 
int
IN6_IS_ADDR_MULTICAST(const struct in6_addr *a)
{
    return (a->s6_bytes[0] == 0xff);
}

 int
IN6_IS_ADDR_LINKLOCAL(const struct in6_addr *a)
{
    return ((a->s6_bytes[0] == 0xfe) &&
            ((a->s6_bytes[1] & 0xc0) == 0x80));
}

 int
IN6_IS_ADDR_SITELOCAL(const struct in6_addr *a)
{
    return ((a->s6_bytes[0] == 0xfe) &&
            ((a->s6_bytes[1] & 0xc0) == 0xc0));
}

int
IN6_IS_ADDR_V4MAPPED(const struct in6_addr *a)
{
    return ((a->s6_dwords[0] == 0) &&
            (a->s6_dwords[1] == 0) &&
            (a->s6_dwords[2] == htonl(0xffff)));
}

 int
IN6_IS_ADDR_V4COMPAT(const struct in6_addr *a)
{
    return ((a->s6_dwords[0] == 0) &&
            (a->s6_dwords[1] == 0) &&
           (a->s6_dwords[2] == 0) &&
            (a->s6_dwords[3] != 0) &&
            (a->s6_dwords[3] != htonl(1)));
}

#endif /* HAVE_IPV6 */